import sys
import hou

from simpleBuilding import *
from controlVariables import *

class buildings:

	def buildings(self,skin):
		
		geo = controlVariables.geo
		
		ed = self.carregarEdifici(geo)

		bas = geo.createNode('basis')
		bas.setFirstInput(skin)
		
		rev = geo.createNode('reverse')
		rev.setFirstInput(bas)
		
		creep = self.encaixar(geo,ed,rev)	

		xform = self.centrar(geo,creep)

		#ed.parm('divrate3').setExpression('2+floor(6*rand(stamp("../copy3","seg",0)))')

		return xform

	
	def carregarEdifici(self,geo):
		theBuilding = geo.createNode('buildingHDA')
		theBuilding.parm('boxHeight').setExpression('2+floor(6*rand(stamp("../copy2","seg",0)))')
		ed = geo.createNode('xform')
		ed.parm('sx').set(6)
		ed.parm('sy').set(6/0.15)
		ed.parm('sz').set(1)
		if controlVariables.districtMap != None:
			ed.parm('ry').set(180)
		ed.setFirstInput(theBuilding)

		#ed = geo.createNode('box')
		#ed.parm('type').set(1)
		#ed.parm('sizex').set(6)
		
		return ed


	def encaixar(self,geo,ed,rev):
		creep = geo.createNode('creep')
		creep.setFirstInput(ed)
		creep.setInput(1,rev)
		creep.parm('tx').set(0.5)
		creep.parm('ty').set(0.5)
		creep.parm('sx').set(0.166667)
		creep.parm('sy').set(1)
		creep.parm('sz').set(0.005)
		
		return creep


	def centrar(self,geo,creep):
		xform = geo.createNode('xform')
		xform.setFirstInput(creep)
		xform.parm('px').setExpression('$CEX')
		xform.parm('py').setExpression('$CEY')
		xform.parm('pz').setExpression('$ZMIN')
		xform.parm('sz').setExpression('(2+floor(6*rand(stamp("../copy2","seg",0))))*0.2')
		
		return xform