import sys
import hou

from grid import *
from radial import *
from compositing import *
from geometry import *
from network import *
from pattern import *

from controlVariables import *

class districts(pattern):

	def districts(self,type):

		controlVariables.distColor1, controlVariables.distColor2

		sur = controlVariables.sur

		glo = sur.createNode('global')
		
		mapfloat = sur.createNode('vectofloat')
		#the districts map
		if type == 'surface':
			map = sur.createNode('texture')
			map.parm('map').set(controlVariables.districtMap)
			map.setInput(1,glo,11)
			map.setInput(2,glo,12)
			mapfloat.setFirstInput(map)
		elif type == 'filter':
			map = sur.createNode('colormap')
			map.parm('cmap').set(controlVariables.districtMap)
			map.setInput(1,glo,22)
			map.setInput(2,glo,23)
			mapfloat.setFirstInput(map)


		if controlVariables.distColor1 != None:
			#determine grid color
			if controlVariables.distColor1=='red':
				red = sur.createNode('constant')
				red.parm('consttype').set(16)
				red.parm('colordefr').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(red)

			elif controlVariables.distColor1=='green':
				green = sur.createNode('constant')
				green.parm('consttype').set(16)
				green.parm('colordefg').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(green)

			elif controlVariables.distColor1=='blue':
				blue = sur.createNode('constant')
				blue.parm('consttype').set(16)
				blue.parm('colordefb').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(blue)

			#compare color to map
			c11 = sur.createNode('compare')
			c11.setFirstInput(gridColor)
			c11.setInput(1,mapfloat)
			c12 = sur.createNode('compare')
			c12.setFirstInput(gridColor,1)
			c12.setInput(1,mapfloat,1)
			c13 = sur.createNode('compare')
			c13.setFirstInput(gridColor,2)
			c13.setInput(1,mapfloat,2)
			
			gridand = sur.createNode('and')
			gridand.setFirstInput(c11)
			gridand.setInput(1,c12)
			gridand.setInput(2,c13)
			
			if1 = sur.createNode('if')
			if1.setFirstInput(gridand)
			controlVariables.sur = if1
			controlVariables.pattern = 'grid'
			self.patterns(type,if1.node('suboutput1'))
		
		if controlVariables.distColor2 != None:
			#determine radial color
			if controlVariables.distColor2=='red':
				red = sur.createNode('constant')
				red.parm('consttype').set(16)
				red.parm('colordefr').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(red)

			elif controlVariables.distColor2=='green':
				green = sur.createNode('constant')
				green.parm('consttype').set(16)
				green.parm('colordefg').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(green)

			elif controlVariables.distColor2=='blue':
				blue = sur.createNode('constant')
				blue.parm('consttype').set(16)
				blue.parm('colordefb').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(blue)
		
			#compare color to map
			c21 = sur.createNode('compare')
			c21.setFirstInput(radialColor)
			c21.setInput(1,mapfloat)
			c22 = sur.createNode('compare')
			c22.setFirstInput(radialColor,1)
			c22.setInput(1,mapfloat,1)
			c23 = sur.createNode('compare')
			c23.setFirstInput(radialColor,2)
			c23.setInput(1,mapfloat,2)
			
			radialand = sur.createNode('and')
			radialand.setFirstInput(c21)
			radialand.setInput(1,c22)
			radialand.setInput(2,c23)
			
			if2 = sur.createNode('if')
			if2.setFirstInput(radialand)
			controlVariables.sur = if2
			controlVariables.pattern = 'radial'
			self.patterns(type,if2.node('suboutput1'))
		
		#adding all of them together
		add = sur.createNode('add')
		add.setFirstInput(if1)
		add.setInput(1,if2)
		
		
		if type == 'surface':
			#wire it to he output node
			out = hou.node('/vex/CityPattern/output1')
		elif type == 'filter':
			out = hou.node('/vex/myPattern/output1')
		out.setFirstInput(add)
		
		for n in sur.children():
		   n.moveToGoodPosition()



	def patterns(self,type,out):

		if controlVariables.pattern == 'grid':
			g = grid()
			g.createSurface(type,out)
		elif controlVariables.pattern == 'radial':
			r = radial()
			r.createSurface(type,out)